function [f,grad,Hessian]=rosenbrock_function(x)
%return the rosenbrock function

f=100*(x(2,:)-x(1,:).^2).^2+(1-x(1,:)).^2;

%a row vector
grad=[-400*x(1,:).*(x(2,:)-x(1,:).^2)-2*(1-x(1,:)) 
       200*(x(2,:)-x(1,:).^2)];
   
%Hessian
Hessian=[-400*(x(2,:)-x(1,:).^2)+800*x(1,:).^2+2, -400*x(1,:);
         -400*x(1,:)                            ,  200*ones(1,length(x(2,:)))];
   
   